/**
 * 
 */
package com.platomix.userprofile.handler.support;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.platomix.userprofile.model.UserprofileTag;
import com.platomix.userprofile.service.UserprofileTagService;

/**
 * @author wookvn
 *	静态标签值生成
 */
@Component
public class UserTagStaticManager {

	@Autowired
	private UserprofileTagService tagService;
	
	/**
	 * 生成微信公众号和小程序标签[产品标签]
	 * 关注公众号的标签值：1、已关注  2、已取关  3、未关注
	 * 针对小程序的标签值：1、未绑定  2、已绑定
	 */
	public void genWeixinBind() {
		List<UserprofileTag> tagList = new ArrayList<>();
		String level1id = "B", level1name = "产品标签"; int level2index = 34;
		//是否关注公众号
		UserprofileTag tag1 = new UserprofileTag(String.format("%s112_%02d_%03d", level1id, level2index, 1), 
				"已取关", null, level1id, level1name, level1id + level2index, "关注公众号", "tag_wxpublic_follow", "0", 0,
				"string", "string", "是否关注公众号", 1);
		tag1.setBucketRight(" = '0'");
		tagList.add(tag1);
		UserprofileTag tag2 = new UserprofileTag(String.format("%s112_%02d_%03d", level1id, level2index, 2), 
				"已关注", null, level1id, level1name, level1id + level2index, "关注公众号", "tag_wxpublic_follow", "0", 0,
				"string", "string", "是否关注公众号", 10);
		tag2.setBucketRight(" = '1'");
		tagList.add(tag2);
		tagList.add(new UserprofileTag(String.format("%s112_%02d_%03d", level1id, level2index, 3), 
				"未关注", null, level1id, level1name, level1id + level2index, "关注公众号", "tag_wxpublic_follow", "0", 0,
				"string", "string", "是否关注公众号", 20));
		//是否绑定小程序
		int wxappLevel2index = 35;
		UserprofileTag tag = new UserprofileTag(String.format("%s112_%02d_%03d", level1id, wxappLevel2index, 1), 
				"已绑定", null, level1id, level1name, level1id + wxappLevel2index, "绑定小程序", "tag_wxapp_bind", "0", 0,
				"string", "string", "是否绑定小程序", 1);
		tag.setBucketRight(" > '1970-01-02'");
		tagList.add(tag);
		tagList.add(new UserprofileTag(String.format("%s112_%02d_%03d", level1id, wxappLevel2index, 2), 
				"未绑定", null, level1id, level1name, level1id + wxappLevel2index, "绑定小程序", "tag_wxapp_bind", "0", 0,
				"string", "string", "是否绑定小程序", 10));
		tagService.saveBatch(tagList);
	}
	
	/**
	 * 
	 */
	public void genClassicTaocan() {
		List<UserprofileTag> tagList = new ArrayList<>();
		String level1id = "A", level1name = "大网标签"; int level2index = 26;
		//是否关注公众号
		UserprofileTag tag1 = new UserprofileTag(String.format("%s112_%02d_%03d", level1id, level2index, 1), 
				"王卡", null, level1id, level1name, level1id + level2index, "王卡副卡套餐", "tag_package_classic", "0", 0,
				"string", "string", "是否王卡或副卡套餐", 1);
		tag1.setBucketFormula("PRODUCT_CLASS_DESC like '%%大王%%'");
		tagList.add(tag1);
		UserprofileTag tag2 = new UserprofileTag(String.format("%s112_%02d_%03d", level1id, level2index, 2), 
				"副卡", null, level1id, level1name, level1id + level2index, "王卡副卡套餐", "tag_package_classic", "0", 0,
				"string", "string", "是否王卡或副卡套餐", 2);
		tag2.setBucketFormula("PRODUCT_CLASS_DESC like '%%副卡%%'");
		tagList.add(tag2);
		tagList.add(new UserprofileTag(String.format("%s112_%02d_%03d", level1id, level2index, 3), 
				"其他", null, level1id, level1name, level1id + level2index, "王卡副卡套餐", "tag_package_classic", "0", 0,
				"string", "string", "是否王卡或副卡套餐", 3));
		tagService.saveBatch(tagList);
	}
}
